;;; The intermediate language: <type>:<body>
;;;
;;; constant:		quote:<constant>
;;; global variable:	global:<symbol>
;;; integrable:		integrable:<symbol>
;;; car/cdr integrable:	integrable:([car|cdr] ...)
;;; local variable:	local:(<unique-id> <orig-symbol> <update flag>)
;;; global assignment:	set!:(<global> <expr>)
;;; local assignment:	set!:(<local> <expr>)
;;; branch:		if:(<expr> <expr> <expr>)
;;; application:	app:(<expr> <expr> ...)
;;; letrec-form:	letrec:(((<local> <expr>) ...) <expr>)
;;; let-form:		let:(((<local> <expr>) ...) <expr>)
;;; lambda-form:	lambda:("fname" (<local> ...) <expr>)
;;; vlambda-form:	vlambda:("fname" (<local> ...) <local> <expr>)
;;; delay-form:		delay:("fname" <expr>)
;;; clambda-form:	clambda:(<local> <expr> "fname" (<local> ...) <expr>)
;;; cvlambda-form:	cvlambda:(<local> <expr>
;;;					"fname" (<local> ...) <local> <expr>)
;;; cdelay-form:	cdelay:(<local> <expr> "fname" <expr>)
;;;
;;; labeled expression:	label:(<label> ((<local> <expr>) ...) <exp>)
;;; goto:		goto:(<label> <expr> ...)
;;;
;;;
;;; set of definitions (only legal as outmost construct):
;;;  definitions:(((<name> . <stuff>) ...) . ((<name> . <stuff>) ...))
;;;
;;; temporarily we have macro-transformers (they should go away... not legal
;;;  in final output):
;;;  transformer:<procedure>
;;;
;;; integrables:
;;;	car, cdr, (cadr), cons, ref, deref, assign, closure,
;;;	get-closure, set-closure, not, +, -, *, <, >, <=, >=, zero?,
;;;	null?, pair?, boolean?, number?, string?, vector?, char?, append,
;;;	vector, list->vector, memv, eqv?
